import javax.swing.*;
import java.awt.event.*;

public class Menu{
	private JRadioButtonMenuItem bidderNumberButton[], recipientNumberButton[];
	private ButtonGroup bidders, recipients, experimentGroup;
	private Simulate s;
	private int experimentNr = 1;
	
	public Menu(Simulate s)
	{
		this.s = s;
	}
	
	public JMenuBar getMenuBar()
	{
		//	MenuBar
		JMenuBar bar = new JMenuBar();

		//Menu item Experiment
		JMenu experiment =new JMenu("Experiment");
		experimentGroup = new ButtonGroup();
		JRadioButtonMenuItem bidMax = new JRadioButtonMenuItem("Bidders bid maximum (1 round)",true);
		bidMax.addActionListener(
				new ActionListener()
				{
					public void actionPerformed(ActionEvent e)
					{
						experimentNr = 1;
					}
				}
		);
		experimentGroup.add(bidMax);
		experiment.add(bidMax);
		
		JRadioButtonMenuItem bidOptimum = new JRadioButtonMenuItem("Bidders bid optimum (1 round)");
		bidOptimum.addActionListener(
				new ActionListener()
				{
					public void actionPerformed(ActionEvent e)
					{
						experimentNr = 2;
					}
				}
		);
		experimentGroup.add(bidOptimum);
		experiment.add(bidOptimum);
		
		JRadioButtonMenuItem bidOptimumAndRemember = new JRadioButtonMenuItem("Bidders bid optimum and remember previous bids (4 rounds)");
		bidOptimumAndRemember.addActionListener(
				new ActionListener()
				{
					public void actionPerformed(ActionEvent e)
					{
						experimentNr = 3;
					}
				}
		);
		experimentGroup.add(bidOptimumAndRemember);
		experiment.add(bidOptimumAndRemember);
		
		JRadioButtonMenuItem fixedAuctionOptimum = new JRadioButtonMenuItem("Fixed Bid | Auction | bid optimum");
		fixedAuctionOptimum.addActionListener(
				new ActionListener()
				{
					public void actionPerformed(ActionEvent e)
					{
						experimentNr = 4;
					}
				}
		);
		experimentGroup.add(fixedAuctionOptimum);
		experiment.add(fixedAuctionOptimum);

		//Menu item start / stop
		JMenu startStop =new JMenu("Start/Stop");
		JMenuItem run = new JMenuItem("Run");
		run.addActionListener(
				new ActionListener()
				{
					public void actionPerformed(ActionEvent e)
					{
						s.setExperiment(experimentNr);
						s.start();
						((JMenuItem)e.getSource()).setEnabled(false);
//						if(!s.halting())
//						{
//							System.out.println("Starting Thread !");
//							s.start();
//						}
//						else
//						{
//							System.out.println("Thread was alive starting runAgain!");
//							s.runAgain();
//						}
					}
				}
		);
		startStop.add(run);
		
		JMenuItem pauze = new JMenuItem("Stop");
		pauze.addActionListener(
				new ActionListener()
				{
					public void actionPerformed(ActionEvent e)
					{
						s.setPauze(Integer.MAX_VALUE);
					}
				}
		);
		startStop.add(pauze);
		
//		JMenuItem stop = new JMenuItem("Stop");
//		stop.addActionListener(
//				new ActionListener()
//				{
//					public void actionPerformed(ActionEvent e)
//					{
//						s.halt();
//						s.initialize(false);
//					}
//				}
//		);
//		startStop.add(stop);
		
//		JMenuItem ffNextRound = new JMenuItem("Fast Forward next Round");
//		startStop.add(ffNextRound);

		//Menu item speed
		JMenu speed =new JMenu("Speed");
		ButtonGroup speedButtons = new ButtonGroup();
		JRadioButtonMenuItem fastest = new JRadioButtonMenuItem("fastest");
		fastest.addActionListener(
				new ActionListener()
				{
					public void actionPerformed(ActionEvent e)
					{
						s.setPauze(0);
					}
				}
		);
		speedButtons.add(fastest);
		speed.add(fastest);
		
		//	0.5 seconds delay
		JRadioButtonMenuItem sec0_5 = new JRadioButtonMenuItem("0.5 sec. delay",true);
		sec0_5.addActionListener(
				new ActionListener()
				{
					public void actionPerformed(ActionEvent e)
					{
						s.setPauze(500);
					}
				}
		);
		speedButtons.add(sec0_5);
		speed.add(sec0_5);
		
		//	1 seconds delay
		JRadioButtonMenuItem sec1 = new JRadioButtonMenuItem("1 sec. delay");
		sec1.addActionListener(
				new ActionListener()
				{
					public void actionPerformed(ActionEvent e)
					{
						s.setPauze(1000);
					}
				}
		);
		speedButtons.add(sec1);
		speed.add(sec1);
		
		// 3 seconds delay
		JRadioButtonMenuItem sec3 = new JRadioButtonMenuItem("3 sec. delay");
		sec3.addActionListener(
				new ActionListener()
				{
					public void actionPerformed(ActionEvent e)
					{
						s.setPauze(3000);
					}
				}
		);
		speedButtons.add(sec3);
		speed.add(sec3);
		
		//	10 seconds delay
		JRadioButtonMenuItem sec10 = new JRadioButtonMenuItem("10 sec. delay");
		sec10.addActionListener(
				new ActionListener()
				{
					public void actionPerformed(ActionEvent e)
					{
						s.setPauze(10000);
					}
				}
		);
		speedButtons.add(sec10);
		speed.add(sec10);

//		Menu item Number of Bidders
		JMenu numberOfBidders =new JMenu("Number of bidders");
		bidders = new ButtonGroup();	
		bidderNumberButton = new JRadioButtonMenuItem[11];
		for (int i = 1; i <= 10; i++)
		{
			boolean selected = (i==10)?true:false;
			bidderNumberButton[i] = new JRadioButtonMenuItem(i + " Bidders",selected);
			bidders.add(bidderNumberButton[i]);
			numberOfBidders.add(bidderNumberButton[i]);
			bidderNumberButton[i].addActionListener(
					new ActionListener()
					{
						public void actionPerformed(ActionEvent e)
						{
							if (e.getActionCommand().substring(1,2).compareTo(" ") != 0)
								s.setNBidders(Integer.parseInt(e.getActionCommand().substring(0, 2)));
							else
								s.setNBidders(Integer.parseInt(e.getActionCommand().substring(0, 1)));
						}
					}
			);
		}


//		Menu item Number of Recipients
		JMenu numberOfRecipients =new JMenu("Number of recipients");
		recipients = new ButtonGroup();	
		recipientNumberButton = new JRadioButtonMenuItem[11];
		for (int i = 1; i <= 10; i++)
		{
			boolean selected = (i==10)?true:false;
			recipientNumberButton[i] = new JRadioButtonMenuItem(i + " Bidders", selected);
			recipients.add(recipientNumberButton[i]);
			numberOfRecipients.add(recipientNumberButton[i]);
			recipientNumberButton[i].addActionListener(
					new ActionListener()
					{
						public void actionPerformed(ActionEvent e)
						{
							if (e.getActionCommand().substring(1,2).compareTo(" ") != 0)
								s.setNRecipients(Integer.parseInt(e.getActionCommand().substring(0, 2)));
							else
								s.setNRecipients(Integer.parseInt(e.getActionCommand().substring(0, 1)));
						}
					}
			);
		}
		
//		Menu item Number of Recipients
		JMenu miscOptions =new JMenu("Misc. options");
		JCheckBox initRandomBidders = new JCheckBox("Random Thresholds");
		initRandomBidders.addItemListener(
				new ItemListener()
				{
					public void itemStateChanged(ItemEvent e)
					{
						JCheckBox cb = (JCheckBox)e.getSource();
					    
			            // Determine status
			            boolean isSel = cb.isSelected();
			            if (isSel) {
			                s.setRandomThresholds(true);
			            } else {
			            	s.setRandomThresholds(false);
			            }
					}
				}
				);
		miscOptions.add(initRandomBidders);

		bar.add(experiment);
		bar.add(startStop);
		bar.add(speed);
		bar.add(numberOfBidders);
		bar.add(numberOfRecipients);
		bar.add(miscOptions);
		return bar;
	}
}
