import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.image.BufferedImage;
import javax.swing.JFrame;

import javax.swing.JPanel;

public class SimulateBoard extends JPanel
	{
	private static final long serialVersionUID = 2L;
		private int NBIDDERS = 10;
		private int NRECIPIENTS = 10;
		private BufferedImage bimage; 
		private static Graphics gim;
		JFrame s;
		public double myNumber;
		
		public SimulateBoard()
		{
			bimage = new BufferedImage(800, 580, BufferedImage.TYPE_INT_RGB);
			gim = bimage.getGraphics();
			myNumber = Math.random();
			System.out.println(myNumber);
			//primary data
			
		}
		
		public void setNBidders(int bidders)
		{
			this.NBIDDERS = bidders;
		}
		
		public void setNRecipients(int recipients)
		{
			this.NRECIPIENTS = recipients;
		}
		
		public void redraw()
		{
			repaint();
		}
		
		public void giveImage(BufferedImage bf)
		{
			this.bimage = bf;
			redraw();
		}
		
		public Dimension getPreferredSize()
		{
			return new Dimension( 800, 580);
		}
		
		public void paintComponent(Graphics g)
		{   
			super.paintComponent(g);
			g.drawImage( bimage, 0, 0, this );	
		}
		
		//bidders, recipients, bids, bidderInfo, r, round)
		public void showAuctionPrior(Agent bidders[], Agent recipients[], float [] bids, int b, int r, int round)
		{
			drawOutlines(bidders, recipients);
			
			gim.drawString("Auction after round " + (round - 1), 340, 70);	
			gim.drawString("Bidder " + (b+1) + " sells", 210, 100);
			gim.drawString("Max proposal " + bidders[b].maxOffer,210,130 );
			gim.drawString("Min proposal " + recipients[r].minAccept,410,130 );
			gim.drawString("Recipient " + (r+1), 410, 100);
			gim.drawString("Auctioning info about recipient " + (r+1),210,160 );
			
			//	information about the information being sold
			//Note that agents do not sell the information they bough
			gim.setColor(Color.black);
			gim.drawRect(220,180,160,10);
			gim.setColor(Color.red);
			gim.fillRect(220,180,16 * bidders[b].acceptLow(recipients[r], false),10);
			gim.drawString(bidders[b].acceptLow(recipients[r], false) + "", 220 + 16 * bidders[b].acceptLow(recipients[r], false) , 180);
			gim.setColor(Color.green);
			gim.fillRect(220 + 16 * bidders[b].acceptHigh(recipients[r], false), 180, 160 - 16 * bidders[b].acceptHigh(recipients[r], false), 10);
			gim.drawString(bidders[b].acceptHigh(recipients[r], false) + "", 220 + 16 * bidders[b].acceptHigh(recipients[r], false) , 180);
			
			//Display all bidding agents
			for (int biddingAgent = 0; biddingAgent < NBIDDERS; biddingAgent++)
			{

				gim.setColor(Color.black);
				gim.drawString("bidder " + (biddingAgent+1) + " knows ["
						+ bidders[biddingAgent].acceptLow(recipients[r], true) + ", " + bidders[biddingAgent].acceptHigh(recipients[r], true)
						+ "] bids: " + (int)(bids[biddingAgent]*100)/100.00, 210, 220 + 25 * biddingAgent);
			}
			redraw();
		}
		
		public void showAuctionPost(Agent bidders[], Agent recipients[], float [] bids, int b, int r, float secondHighest, int idx, int round)
		{
			if (idx != -1)//if there is a winner
			{
				gim.setColor(Color.red);
				gim.drawString("Winner" + (idx+1) + " updated to["
						+ bidders[idx].acceptLow(recipients[r], true) + ", " + bidders[idx].acceptHigh(recipients[r], true) 
						+ "] pays: " + (int)(secondHighest*100)/100.0,210, 470);
				redraw();
			}
		}
		
		public  void showTradePrior(Agent bidders[], Agent recipients[], int b, int r,String strategy, int round)
		{
			drawOutlines(bidders, recipients);
			
			//text
			gim.drawString("Bidder " + (b + 1), 210, 100);
			gim.drawString("Recipient " + (r + 1), 410, 100);
			gim.drawString(strategy + " Trading Round " + round, 320, 70);
			gim.drawString("Max proposal " + bidders[b].maxOffer,210,130 );
			gim.drawString("Min proposal " + recipients[r].minAccept,410,130 );
			gim.drawString("Prior Information about recipient " + (recipients[r].askId()+1),210,160 );
			//gim.drawString("Offering: " + bid, 210, 220);
			
			//information charts 160 pixels wide	
			gim.setColor(Color.black);
			gim.drawRect(220,180,160,10);
			gim.setColor(Color.red);
			gim.fillRect(220,180,16 * bidders[b].acceptLow(recipients[r], true),10);
			gim.drawString(bidders[b].acceptLow(recipients[r], true) + "", 220 + 16 * bidders[b].acceptLow(recipients[r], true) , 180);
			gim.setColor(Color.green);
			gim.fillRect(220 + 16 * bidders[b].acceptHigh(recipients[r], true), 180, 160 - 16 * bidders[b].acceptHigh(recipients[r], true), 10);
			gim.drawString(bidders[b].acceptHigh(recipients[r], true) + "", 220 + 16 * bidders[b].acceptHigh(recipients[r], true) , 180);
			redraw();
		}
		
		public  void showTradePost(Agent bidders[], Agent recipients[], int b, int r, int bid, String strategy, int round)
		{
			gim.setColor(Color.black);
			gim.drawString("Post Information about recipient " + (recipients[r].askId()+1),210,250 );
			gim.drawString("Offering: " + bid, 210, 220);
			gim.drawLine(200,230,400,230);
			//information charts 160 pixels wide	
			gim.setColor(Color.black);
			gim.drawRect(220,270,160,10);
			gim.setColor(Color.red);
			gim.fillRect(220,270,16 * bidders[b].acceptLow(recipients[r], true),10);
			gim.drawString(bidders[b].acceptLow(recipients[r], true) + "", 220 + 16 * bidders[b].acceptLow(recipients[r], true) , 270);
			gim.setColor(Color.green);
			gim.fillRect(220 + 16 * bidders[b].acceptHigh(recipients[r], true), 270, 160 - 16 * bidders[b].acceptHigh(recipients[r], true), 10);
			gim.drawString(bidders[b].acceptHigh(recipients[r], true) + "", 220 + 16 * bidders[b].acceptHigh(recipients[r], true) , 270);
			redraw();
		}
		
		public  void drawOutlines(Agent bidders[], Agent recipients[])
		{
			//		graphics
			gim.setColor(Color.lightGray);
			gim.fillRect(0,0,800,600);
			
			//Bidder field	
			gim.setColor(Color.black);
			gim.drawRect(10, 15, 160, 520);
			
			gim.setFont(new Font("SERIF", Font.BOLD, 11));
			gim.drawString("Bidders:", 20, 30);
			for (int b = 0; b < NBIDDERS; b++)
			{
				float m = bidders[b].myScore;
				m = (float)((int)(m * 10)/10.0);
				String money = (m > 99)? m+"": ((m > 9)?(" " + m): "  " + m); 
				gim.drawString("Bidder " + (b + 1)+ ",  p<=" + bidders[b].maxOffer + ",  $" + money, 20, 50 * b + 60);
			}
			
			//Recipient field
			gim.setColor(Color.black);
			gim.drawRect(630, 15, 160, 520);
			for (int r = 0; r < NRECIPIENTS; r++)
			{
				float m = recipients[r].myScore;
				m = (float)((int)(m * 10)/10.0);
				String money = (m > 99)? m+"": ((m > 9)?(" " + m): "  " + m);
				//rounding
				gim.drawString("Recipients:", 640, + 30);
				gim.drawString("Recipient " + (r + 1) + ",  p>=" + recipients[r].minAccept + ",  $" + money, 640, 50 * r + 60);
			}
		
			//main outline
			gim.drawRect(250, 50, 300, 30);
			gim.drawRect(200, 80, 400, 400);
			gim.drawLine(200, 110, 600, 110);
			gim.drawLine(400, 80, 400, 480);
			
			//spacing
			gim.drawLine(200, 140, 600, 140);
			gim.drawLine(200, 200, 600, 200);
		}
	}
